#if defined(__linux__)
#define _XOPEN_SOURCE 600
#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#endif

#include <unistd.h>
#include <dirent.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/statvfs.h>
#include <fcntl.h>

off_t
lseek_wrap(int fildes, off_t offset, int whence) {
    return lseek(fildes, offset, whence);
}

int
truncate_wrap(const char *path, off_t length) {
    return truncate(path, length);
}

int
ftruncate_wrap(int fd, off_t length) {
    return ftruncate(fd, length);
}

void*
mmap_wrap(void *start, size_t length, int prot, int flags, int fd, off_t offset) {
    return mmap(start, length, prot, flags, fd, offset);
}

int
stat_wrap(const char *file_name, struct stat *buf) {
    return stat(file_name, buf);
}

int
fstat_wrap(int filedes, struct stat *buf) {
    return fstat(filedes, buf);
}

int
lstat_wrap(const char *file_name, struct stat *buf) {
    return lstat(file_name, buf);
}

ssize_t
pread_wrap(int fd, void *buf, size_t count, off_t offset) {
    return pread(fd, buf, count, offset);
}

ssize_t
pwrite_wrap(int fd, const void *buf, size_t count, off_t offset) {
    return pwrite(fd, buf, count, offset);
}

int
readdir_r_wrap(DIR *dirp, struct dirent *entry, struct dirent **result) {
    return readdir_r(dirp, entry, result);
}

int
getrlimit_wrap(int resource, struct rlimit *rlim) {
    return getrlimit(resource, rlim);
}

int
setrlimit_wrap(int resource, const struct rlimit *rlim) {
    return setrlimit(resource, rlim);
}

int
statvfs_wrap(const char *path, struct statvfs *buf) {
	return statvfs(path, buf);
}

int
fstatvfs_wrap(int fd, struct statvfs *buf) {
	return fstatvfs(fd, buf);
}

int
fcntl_without_arg_wrap(int fd, int cmd) {
    return fcntl(fd, cmd);
}

// FIXME: on Linux/glibc ARG is a LONG, for Posix it's an INT
//        is this an issue ?
int
fcntl_with_int_arg_wrap(int fd, int cmd, int arg) {
    return fcntl(fd, cmd, arg);
}

int
fcntl_with_pointer_arg_wrap(int fd, int cmd, void *arg) {
    return fcntl(fd, cmd, arg);
}
